// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from py_trees_ros_interfaces:srv/OpenSnapshotStream.idl
// generated code does not contain a copyright notice

#ifndef PY_TREES_ROS_INTERFACES__SRV__DETAIL__OPEN_SNAPSHOT_STREAM__TRAITS_HPP_
#define PY_TREES_ROS_INTERFACES__SRV__DETAIL__OPEN_SNAPSHOT_STREAM__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "py_trees_ros_interfaces/srv/detail/open_snapshot_stream__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'parameters'
#include "py_trees_ros_interfaces/msg/detail/snapshot_stream_parameters__traits.hpp"

namespace py_trees_ros_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const OpenSnapshotStream_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: topic_name
  {
    out << "topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.topic_name, out);
    out << ", ";
  }

  // member: parameters
  {
    out << "parameters: ";
    to_flow_style_yaml(msg.parameters, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OpenSnapshotStream_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: topic_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.topic_name, out);
    out << "\n";
  }

  // member: parameters
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "parameters:\n";
    to_block_style_yaml(msg.parameters, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OpenSnapshotStream_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::srv::OpenSnapshotStream_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::srv::OpenSnapshotStream_Request & msg)
{
  return py_trees_ros_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::OpenSnapshotStream_Request>()
{
  return "py_trees_ros_interfaces::srv::OpenSnapshotStream_Request";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::OpenSnapshotStream_Request>()
{
  return "py_trees_ros_interfaces/srv/OpenSnapshotStream_Request";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<py_trees_ros_interfaces::srv::OpenSnapshotStream_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace py_trees_ros_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const OpenSnapshotStream_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: topic_name
  {
    out << "topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.topic_name, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OpenSnapshotStream_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: topic_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "topic_name: ";
    rosidl_generator_traits::value_to_yaml(msg.topic_name, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OpenSnapshotStream_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::srv::OpenSnapshotStream_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::srv::OpenSnapshotStream_Response & msg)
{
  return py_trees_ros_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::OpenSnapshotStream_Response>()
{
  return "py_trees_ros_interfaces::srv::OpenSnapshotStream_Response";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::OpenSnapshotStream_Response>()
{
  return "py_trees_ros_interfaces/srv/OpenSnapshotStream_Response";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<py_trees_ros_interfaces::srv::OpenSnapshotStream_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace py_trees_ros_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const OpenSnapshotStream_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const OpenSnapshotStream_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const OpenSnapshotStream_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace py_trees_ros_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use py_trees_ros_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const py_trees_ros_interfaces::srv::OpenSnapshotStream_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  py_trees_ros_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use py_trees_ros_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const py_trees_ros_interfaces::srv::OpenSnapshotStream_Event & msg)
{
  return py_trees_ros_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::OpenSnapshotStream_Event>()
{
  return "py_trees_ros_interfaces::srv::OpenSnapshotStream_Event";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::OpenSnapshotStream_Event>()
{
  return "py_trees_ros_interfaces/srv/OpenSnapshotStream_Event";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Event>
  : std::integral_constant<bool, has_bounded_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Request>::value && has_bounded_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<py_trees_ros_interfaces::srv::OpenSnapshotStream_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<py_trees_ros_interfaces::srv::OpenSnapshotStream>()
{
  return "py_trees_ros_interfaces::srv::OpenSnapshotStream";
}

template<>
inline const char * name<py_trees_ros_interfaces::srv::OpenSnapshotStream>()
{
  return "py_trees_ros_interfaces/srv/OpenSnapshotStream";
}

template<>
struct has_fixed_size<py_trees_ros_interfaces::srv::OpenSnapshotStream>
  : std::integral_constant<
    bool,
    has_fixed_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Request>::value &&
    has_fixed_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Response>::value
  >
{
};

template<>
struct has_bounded_size<py_trees_ros_interfaces::srv::OpenSnapshotStream>
  : std::integral_constant<
    bool,
    has_bounded_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Request>::value &&
    has_bounded_size<py_trees_ros_interfaces::srv::OpenSnapshotStream_Response>::value
  >
{
};

template<>
struct is_service<py_trees_ros_interfaces::srv::OpenSnapshotStream>
  : std::true_type
{
};

template<>
struct is_service_request<py_trees_ros_interfaces::srv::OpenSnapshotStream_Request>
  : std::true_type
{
};

template<>
struct is_service_response<py_trees_ros_interfaces::srv::OpenSnapshotStream_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // PY_TREES_ROS_INTERFACES__SRV__DETAIL__OPEN_SNAPSHOT_STREAM__TRAITS_HPP_
